<template>
  <v-row>
    <v-col>
      <head-bar :title="pageTitle" cart />

      <!-- Orders in progress -->
      <h2><v-icon>mdi-progress-clock</v-icon> Current orders</h2>
      <order-list :orders="currentOrders"></order-list>

      <!-- Orders history -->
      <h2><v-icon>mdi-history</v-icon> Past orders</h2>
      <order-list :orders="pastOrders"></order-list>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      pageTitle: 'Orders',
      orders: [],
    }
  },
  computed: {
    currentOrders(): Array<object> {
      return this.orders.filter((order: any) =>
        ['pending', 'preparing', 'delivering'].includes(order.status)
      )
    },
    pastOrders(): Array<object> {
      return this.orders.filter((order: any) =>
        ['delivered', 'cancelled'].includes(order.status)
      )
    },
  },
  methods: {
    async getOrders() {
      this.orders = (
        await this.$axios.$get(
          'http://consumer.localhost:4000/consumers/' +
            this.$store.state.loggedIn +
            '/orders'
        )
      )[0].orders
    },
  },
  mounted() {
    this.getOrders()
  },
})
</script>
